# shout/plugs/output.py
#
#

""" lists various stuff. """

## zbot imports

from zbot.utils import striphtml, ptime, dtime, tdiff
from zbot import cmnds, plugins, tools, config, Object
from zbot.generic import need_skip, reduced

## basic imports

import datetime
import logging
import time

## output command

def do_output(event):
    opts = event.options
    attrs = event.args
    logging.warn("attributes used: %s" % attrs) 
    c = 0
    next = True
    res = []
    otype = opts.otype or "txt"
    try: fr = ptime(opts.fr or "1984-01-01")  ; to = ptime(opts.to or "2013-12-30")
    except ValueError as ex: event.reply("error: %s" % str(ex)) ; return
    reslist = []
    uniqlist = []
    for obj in sorted(event.objects(), key=lambda o: str(o.estamp)):
        if need_skip(obj, black=["html",], white=["text",]): continue
        c += 1
        try: diff = int(opts.diff)  
        except ValueError: diff = 0
        daysdiff = diff*60*60*24
        if obj.estamp:
            if obj.estamp < fr.timestamp(): continue
            if obj.estamp > to.timestamp(): continue
            if daysdiff and (time.time() - obj.estamp) > daysdiff: continue 
            obj.days = datetime.timedelta(-1, time.time() - obj.estamp)
        obj.nr = c
        result = ""
        value = ""
        lines = 0
        attrlist = sorted(reduced(obj))
        uniq = False
        for attr in attrlist:
            if attr.endswith("-uniq"): a = attr.split("-")[0] ; uniq = True
            else: uniq = False ; a = attr
            try:
                value = obj[a]
                strval = str(value)
                lines += 1
            except KeyError: continue
            if a in opts:
               if a.endswith("-excl"): excl = True
               else: excl = False
               val = str(opts[a]).lower()
               if excl and val in strval.lower(): next = False ; break
               elif val not in strval.lower(): next = False ; break
            if a in attrs: 
                r1 = '%s: %s ' % (a, strval)
                if uniq:
                   if r1 in uniqlist: next = False ; break
                   else: uniqlist.append(r1)
                result += r1
        if not next: next = True ; continue     
        if result not in res: res.append(result)
        if otype not in ["txt", ]: event.reply(obj.dump() + "\r\n") 
    if otype in ["txt", ]:
        for data in res:
            if data: event.reply(data)    
    logging.warn("%s objects counted" % c)
    logging.warn("used options: %s" % opts)
 
cmnds.register("out", do_output)
